;  .    - ADC2,
; - ADC3.     ,  =1 
; - 10/255,  =10 - 200/255.    
;  .  - 9.6    RC.
#include "tn13def.inc"
.DEVICE ATTiny13

.DSEG

		dirh: .BYTE 1
		dirl: .BYTE 1
		refh: .BYTE 1
		refl: .BYTE 1
		kswn: .BYTE 1

.CSEG
.ORG 0x000A

RESET:	wdr
		in  r16,WDTCR
		ori r16,(1<<WDCE)|(1<<WDE)
		out WDTCR,r16
        ldi r16,0b00100001 
        out WDTCR,r16      ; WDT  8 .

        ldi r16,0b00000001 ;   B.
		out DDRB,r16
		ldi r16,0b00000110 ; 0  PB0,  pullup  PB1,PB2.
		out PORTB,r16
		sbi ACSR,ACD       ;  .
		ldi r16,0b00011000
		out DIDR0,r16      ;  .  . .

		ldi r16,0b10000011
		out TCCR0A,r16
		ldi r16,0b00000001
		out TCCR0B,r16     ;    .
		ldi r16,0b00000000 ;  0.
		out OCR0A,r16

LL01:	ldi r16,0b00000010 ;  2 ,  = VCC.
		out ADMUX,r16
		rcall DELAYSHT
		ldi r16,0b11000110 ; .
		out ADCSRA,r16
WL01:  	in  r16,ADCSRA     ;   .
		andi r16,0b00010000
		cpi r16,0b00010000
		brne WL01
		sbi ADCSRA,ADIF ;    .		

		in r16,ADCL
		sts dirl,r16
		in r16,ADCH
		sts dirh,r16 ;       . 
        
        ldi r16,0b00000011 ;  3 ,  = VCC.
		out ADMUX,r16
		rcall DELAYSHT
		ldi r16,0b11000110 ; .
		out ADCSRA,r16
WL02:  	in  r16,ADCSRA     ;   .
		andi r16,0b00010000
		cpi r16,0b00010000
		brne WL02
		sbi ADCSRA,ADIF ;    .		

		in r16,ADCL
		sts refl,r16
		in r16,ADCH
		sts refh,r16 ;       .

		rcall CLKSW  ;   . 
		
		in r16,PINB
		andi r16,0b00000110
		cpi r16,0b00000110
		brne WL3
		rjmp WL4
WL3:	rcall DVDIR   ;      , .
		 
WL4:	lds r16,kswn
			
		out OCR0A,r16 ;   .
		rcall DELAYLNG

		wdr          ;   . 
        rjmp LL01    ;    .

;========================================================


DELAYSHT:ldi r16,0x0F
S1:		ldi r17,0xFF
S2:     dec r17
        brne S2
		dec r16
		brne S1 ;  .
		ret
;========================================================
DELAYLNG:ldi r16,0xFF
S3:		ldi r17,0xFF
S4:     dec r17
        brne S4
		dec r16
		brne S3 ;  .
		ret
;========================================================

CLKSW:  nop
		lds r16,dirl
		lds r17,dirh
		
		cpi r17,0x03
		brne DOCM
		cpi r16,0xFF
		breq ECSWB ;     Vdir.

DOCM:  	lds r20,refl
		lds r21,refh
		
		cp r21,r17
		brlo DOCL
		cp r17,r21
		brlo ECSWB
		cp r20,r16
		brsh ECSWB ;   Vref>=Vdir.

DOCL:	add r16,r20
		adc r17,r21 ;   r17:r16.
    
		clr r20
		clr r21
		ldi r22,0x14
MUX20:  add r20,r16
		adc r21,r17
		dec r22
		brne MUX20   ;,    20.	
        mov r16,r20
        mov r17,r21	
	    
	    lds r20,refl
		lds r21,refh
		lds r18,dirl
		lds r19,dirh
		sub r18,r20
		sbc r19,r21  ;   r19:r18.
		
		rcall div16u ;,   r17:r16,   r15:r14.
		
		sts kswn,r16 ;    .

		cpi r17,0
		brne ECSUM
		subi r16,201
		brsh ECSUM  ;   >10.
		
		
		rjmp ECSW
ECSUM:  ldi r16,200 ;   >10.
		sts kswn,r16
		rjmp ECSW
ECSWB:  ldi r16,0 ;  -  
		sts kswn,r16 ;  Vref>=Vdir.
ECSW:	ret
;========================================================

DVDIR:  cpi r16,4
		breq WL5
		cpi r16,2
		breq WL6
		cpi r16,0
		breq WL7
WL5:	lds r16,dirl
		lds r17,dirh
		clr r19
		ldi r18,5
		rcall div16u
		sts kswn,r16 ;     Vdir.
		rjmp EDV
WL6:	lds r16,refl
		lds r17,refh
		clr r19
		ldi r18,5
		rcall div16u
		sts kswn,r16 ;     Vref.
		rjmp EDV
WL7:	ldi r16,200  ;       .
		sts kswn,r16
EDV:	ret


;   .   AVR200: Multiply and Divide
; Routines.  DOC0936.pdf, AVR200.zip. 
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*  
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :5 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH,
;*			    dcnt16u)
;*
;***************************************************************************

;***** Subroutine Register Variables

.def	drem16uL=r14
.def	drem16uH=r15
.def	dres16uL=r16
.def	dres16uH=r17
.def	dd16uL	=r16
.def	dd16uH	=r17
.def	dv16uL	=r18
.def	dv16uH	=r19
.def	dcnt16u	=r20

;***** Code

div16u:	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,17	;init loop counter
d16u_1:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	d16u_2		;if done
	ret			;    return
d16u_2:	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_3		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	d16u_1		;else
d16u_3:	sec			;    set carry to be shifted into result
	rjmp	d16u_1


